$(function() {
	// TODO: Scaling
	// TODO: Animation

	// Store slides by their types
	var slides = {},
		slideTypes = [],
		curSlide = null,
		popupZIndex,
		lastSlide = null,
		audioPlayer = audiojs.createAll();
	$.each($('.l-slide'), function(index, slide){
		var $slide = $(slide),
			type = slide.className.replace(/^.*?type\_([a-z]+).*?$/gi, '$1');
		if ( ! $slide.hasClass('i-skipslide')) slideTypes.push(type);
		slides[type] = $slide;
	});

	// Provide touch support
	if ('ontouchstart' in document){
		document.body.onselectstart = function() { return false; };
		document.body.unselectable = "on";
	}

	var openSlide = function(index){
			// Provide hash changes for instant calls
			if ($.address.path() != '/'+index) return $.address.path('/'+index);
			if (index == curSlide || slides[index] === undefined) return;
			if (curSlide !== null) slides[curSlide].removeClass('active');
			// reset popups visibility & position
			popupZIndex = 1000;
			slides[index].find('.w-popup').removeAttr('style').removeClass('active');
			slides[index].addClass('active');
			lastSlide = curSlide;
			curSlide = index;
		},
		openNext = function(){
			var curIndex = slideTypes.indexOf(curSlide),
				nextIndex = (curIndex == slideTypes.length - 1) ? 0 : (curIndex + 1),
				nextType = slideTypes[nextIndex];
			openSlide(nextType);
		},
		openPrev = function(){
			var curIndex = slideTypes.indexOf(curSlide),
				prevIndex = (curIndex == 0) ? (slideTypes.length - 1) : (curIndex - 1),
				prevType = slideTypes[prevIndex];
			openSlide(prevType);
		};

	// Top menu button
	$('.i-menu').on('click touchstart', function(e){
		e.preventDefault();
		openSlide((curSlide == 'u') ? (lastSlide || 'a') : 'u');
	});

	// Popups
	$('.w-popup.type_default').draggable({cursor: "move", containment: "parent",
		start: function() {
			$(this).css('z-index', popupZIndex++);
		}
	}).on('click touchstart', function(e) {
		//e.preventDefault(); wtf
		$(this).css('z-index', popupZIndex++);
	});
	$('.w-popup-close').on('click touchstart', function() {
		$(this).parent().removeClass('active').removeAttr('style');
	});
	if ('ontouchstart' in document) $('.w-popup.type_simple').on('touchstart', function(){
		$(this).removeClass('active').removeAttr('style');
	});

	// Rating togglers
	var starWidth = 23;
	$('.g-rating').each(function(index, rating){
		var $rating = $(rating),
			$ratingH = $rating.find('.g-rating-h'),
			$input = $rating.find('input'),
			countValueByEvent = function(e){ return Math.ceil((e.pageX - $rating.offset().left) / starWidth); };
		$rating.mousemove(function(e){
			$ratingH.css('width', countValueByEvent(e) * starWidth);
		}).mouseleave(function(){
			$ratingH.css('width', $input.val() * starWidth);
		}).click(function(e){
			$input.val(countValueByEvent(e));
		});
	});

	// Feedback
	var $feedback = $('.w-feedback');
	$feedback.find('.i-captcha').click(function(){
		$(this).attr('src', 'feedback/3DCaptcha.php?'+(Math.random()+'').substr(2));
	});
	$feedback.submit(function(e){
		e.preventDefault();
		$.ajax({
			type: 'POST',
			data: $feedback.serialize(),
			url: $feedback.attr('action'),
			dataType: 'json',
			success: function(json){
				if (json.success){
					// Replace
					$feedback.html(json.message || '');
				}else{
					$.each(json.errors, function(errName, errText){
						var errInput = $feedback.find('[name='+errName+']');
						if ( ! errInput.hasClass('i-error')){
							$('<p class="i-error-text">'+errText+'</p>').insertAfter(errInput.addClass('i-error'));
						}
					});
				}
			}
		});
	});

	// Prev/next
	var slidesContainer = $('.l-slides'),
		navPrev = $('.l-slides-nav.to_prev').css({opacity: 0, left:  -80}).click(openPrev),
		navNext = $('.l-slides-nav.to_next').css({opacity: 0, right: -80}).click(openNext),
		slideWidth = slidesContainer.width();
	if ( ! ('ontouchstart' in document)){
		// Desktop devices
		slidesContainer.mouseleave(function(){
			navPrev.animate({opacity: 0, left: -80}, {duration: 250, queue: false});
			navNext.animate({opacity: 0, right: -80}, {duration: 250, queue: false});
		}).mousemove(function(e){
			var offset = slidesContainer.offset(),
				clientX = e.pageX - offset.left,
				prevProgress = Math.max(0, Math.min(1, (slideWidth - 3 * clientX) / slideWidth)),
				nextProgress = Math.max(0, Math.min(1, (3 * clientX - 2 * slideWidth) / slideWidth));
			navPrev.css({opacity: prevProgress, left: -80 + 80 * prevProgress});
			navNext.css({opacity: nextProgress, right: -80 + 80 * nextProgress});
		});
	}
	$(document).on('keydown', function(e){
		if (e.which == 37) openPrev();
		if (e.which == 39) openNext();
	});

	// Zoom stuff
	var $page = $('.l-page'),
		updateZoom = function(){
			var winWidth = $(window).width(),
				winHeight = $(window).height(),
				winProp = winWidth / winHeight,
				appWidth = 1024,
				appHeight = 768,
				appProp = appWidth / appHeight,
				zoom = 1;
			// scale by height
			if (winProp > appProp) zoom = winHeight / appHeight;
			// scale by width
			else zoom = winWidth / appWidth;
			// Zoom cannot be less than 1
			zoom = Math.max(1, zoom);
			if ($.browser.mozilla || $.browser.iphone){
				$page.css('transform-origin', '50% 0%');
				$page.css('transform', 'scale('+zoom+','+zoom+')');
			}else{
				$page.css('zoom', zoom);
			}
			slideWidth = appWidth * zoom;
		};
	$(window).resize(updateZoom);
	updateZoom();

	// Popup show on hover
	$('.i-popup.type_hover').hover(function() {
		$(this).parents('.l-slide').find('.w-popup').eq($(this).data('index')).css('z-index', popupZIndex++).addClass('active');
	}, function() {
		$(this).parents('.l-slide').find('.w-popup').eq($(this).data('index')).removeClass('active');
	});
	if ('ontouchstart' in document){
		$('.i-popup.type_hover').on('touchstart', function(){
			$(this).parents('.l-slide').find('.w-popup').eq($(this).data('index')).css('z-index', popupZIndex++).addClass('active');
		});
	}

	// Popup toggle on click and touch
	$('.i-popup.type_click').on('click touchstart', function() {
		$(this).parents('.l-slide').find('.w-popup').eq($(this).data('index')).css('z-index', popupZIndex++).toggleClass('active');
	});

	// Slide b : icharts
	var classLists = [['rate_industry', 'rate_finance'], ['source_rsbu', 'source_msfo'], ['period_year', 'period_halfyear']],
		bCheckboxes = $('.l-slide.type_b .g-switcher input');
	$('.l-slide.type_b .g-switcher').each(function(swIndex, switcher){
		var $switcher = $(switcher),
			$input = $switcher.find('input'),
			iBtn = $input.iButton({
				labelOn: '',
				labelOff: '',
				resizeHandle: false,
				resizeContainer: false,
				change: function(check, ibtn){
					$(check).parents('.w-chartgrid')
						[check[0].checked?'removeClass':'addClass'](classLists[swIndex][0])
						[check[0].checked?'addClass':'removeClass'](classLists[swIndex][1]);
				}
			});
		$switcher.find('.g-switcher-label').each(function(lbIndex, label){
			$(label).on('click touchstart', function(e){
				e.preventDefault();
				$input.iButton("toggle", !!lbIndex);
			});
		});
	});

	// Hover replaced by togglable tap
	if ('ontouchstart' in document) $('.i-togglable').on('touchstart', function(){ $(this).toggleClass('active'); });

	// Slide I/J switcher
	$('.i-yearswitcher').each(function(swIndex, switcher){
		var $switcher = $(switcher),
			$input = $switcher.find('input'),
			iBtn = $input.iButton({
				labelOn: '',
				labelOff: '',
				resizeHandle: false,
				resizeContainer: false,
				change: function(check, ibtn){
					$(check).parents('.w-chartgrid')
						[check[0].checked?'removeClass':'addClass']('for_years')
						[check[0].checked?'addClass':'removeClass']('for_halfyears');
				}
			});
		$switcher.find('.g-switcher-label').each(function(lbIndex, label){
			$(label).on('click touchstart', function(e){
				e.preventDefault();
				$input.iButton("toggle", !!lbIndex);
			});
		});
	});

	// Slide F switcher
	$('.i-fswitcher').each(function(swIndex, switcher){
		var $switcher = $(switcher),
			$input = $switcher.find('input'),
			iBtn = $input.iButton({
				labelOn: '',
				labelOff: '',
				resizeHandle: false,
				resizeContainer: false,
				change: function(check, ibtn){
					$(check).parents('.l-slide')
						[check[0].checked?'addClass':'removeClass']('for_' + swIndex);
				}
			});
	});

	// Slide P switcher
	$('.i-pswitcher').each(function(swIndex, switcher){
		var $switcher = $(switcher),
			$input = $switcher.find('input'),
			iBtn = $input.iButton({
				labelOn: '',
				labelOff: '',
				resizeHandle: false,
				resizeContainer: false,
				change: function(check, ibtn){
					$(check).parents('.w-graph')
						[check[0].checked?'removeClass':'addClass']('for_type1')
						[check[0].checked?'addClass':'removeClass']('for_type2');
				}
			});
		$switcher.find('.g-switcher-label').each(function(lbIndex, label){
			$(label).on('click touchstart', function(e){
				e.preventDefault();
				$input.iButton("toggle", !!lbIndex);
			});
		});
	});

	// Slide R switcher
	$('.i-sourceswitcher').each(function(swIndex, switcher){
		var $switcher = $(switcher),
			$input = $switcher.find('input'),
			iBtn = $input.iButton({
				labelOn: '',
				labelOff: '',
				resizeHandle: false,
				resizeContainer: false,
				change: function(check, ibtn){
					$(check).parents('.w-chartgrid')
						[check[0].checked?'removeClass':'addClass']('for_rsbu')
						[check[0].checked?'addClass':'removeClass']('for_msfo');
				}
			});
		$switcher.find('.g-switcher-label').each(function(lbIndex, label){
			$(label).on('click touchstart', function(e){
				e.preventDefault();
				$input.iButton("toggle", !!lbIndex);
			});
		});
	});

	// Slide g
	var gFunc = 'mouseenter';
	if ('ontouchstart' in document) gFunc = 'touchstart';
	$('.l-slide.type_g .w-table tbody tr').on(gFunc, function() {
		var container = $('.l-slide.type_g')[0];
		container.className = container.className.replace(/ hover\_[0-9]+/ig, '')+' '+$(this).attr('class');
	});

	// Slide O
	$('.i-notpopup').on('click touchstart', function(e) {
		e.preventDefault();
		$(this).toggleClass('active');
	});

	// w-map
	$('.w-map area').hover(function() {
		$(this).parents('.w-map').find('.w-map-hover').removeClass('active').eq($(this).index()).addClass('active');
	}, function() {
		$(this).parents('.w-map').find('.w-map-hover').removeClass('active');
	});

	// Deep linking
	$('.i-link').address();
	$.address.change(function(event){
		var newSlide = event.value.substring(1, 2);
		openSlide(newSlide);
	});

	$('#toggle_rsbu').on('click touchstart', function(e) {
		e.preventDefault();
		$('.l-slide.type_b .g-switcher-label.rate_finance').trigger('click');
		$('.l-slide.type_b .g-switcher-label.source_rsbu').trigger('click');
	});
	$('#toggle_msfo').on('click touchstart', function(e) {
		e.preventDefault();
		$('.l-slide.type_b .g-switcher-label.rate_finance').trigger('click');
		$('.l-slide.type_b .g-switcher-label.source_msfo').trigger('click');
	});

	// Player
	$('.i-play').on('click touchstart', function(e) {
		e.preventDefault(e);
		audioPlayer[0].playPause();
		$(this).toggleClass('active');
	});

	$(window).load(function() {
		$('body').removeClass('preload');
		if ($.address.value() == '/') openSlide('a');
	});

});
